#include "pixt.h"

char *helptext;

char *helpstr[] = {
"                      PIXT",
"  Pixt is, simply, a pixmap editor. It is",
"  obviously styled somewhat after the",
"  ubiquitous `bitmap' program.",
"",
"  BASIC OPERATION",
"  ----- ---------",
"",
"  Mouse Button 1 - Clicking MB1 in the grid",
"  area will paint the affected `pixels' in the",
"  current color. The current color is always",
"  displayed in the large rectangular area just",
"  above the color palette.",
"",
"  Mouse Button 2 - Clicking MB2 in the grid",
"  area will `clear' the affected pixel. That",
"  is, the color of that pixel will revert to",
"  the default background color, which is always",
"  white.",
"",
"  Mouse Button 3 - Clicking MB3 in the grid",
"  area is one of the methods for choosing a",
"  current color. Whatever color the pixel is",
"  that you click MB3 on will be selected as the  ",
"  current color.",
"",
"  Color Palette - Clicking MB1 on a color",
"  button in the palette selects that color as",
"  the current color.",
"",
"  FILE MENU",
"  ---- ----",
"",
"  The only menu items currently implemented",
"  are:",
"	Read a Pixt Pixmap",
"	Write a Pixt Pixmap",
"	Write a UIL Icon",
"",
"  EDIT MENU",
"  ---- ----",
"",
"  Capture Image From Screen - This allows you",
"  to capture a pixel image from the screen so",
"  that it can be edited. When this item is",
"  selected the cursor will change to a flashing  ",
"  box that can be positioned anywhere on the",
"  screen. Pressing any mouse button will cause",
"  the pixels contained by the cursor box to be",
"  captured into Pixt. This overwrites the",
"  previous pixmap being edited.",
"",
"  Global Color Change - This function will",
"  convert all pixels of one color to another.",
"  After selecting this menu item you then",
"  position the cursor over a pixel that is the",
"  color you want to replace. Use MB3 to",
"  activate the function. All instances of that",
"  color will be replaced with the current",
"  color.",
"",
"  DRAW MENU",
"  ---- ----",
"  ",
"  The line function sort of works. After",
"  selecting this function click MB1 on each end",
"  of the line.",
"",
"  Clear Pixmap will wipe out the current pixmap  ",
"  by making each pixel white.",
"  ",
"  REGION MENU",
"  ------ ----",
"  ",
"  The items in this menu allow you to work with",
"  a portion of the pixmap.",
"  ",
"  Hide - deselect the current region",
"  Mark - mark a region for manipulation; after",
"         selecting this function, click MB1 in",
"         opposite corners of the desired",
"         region. This `active region' is then",
"         highlighted.",
"  Copy - copy the active region to somewhere ",
"         else in the pixmap; after selecting",
"         this function, click MB1 on the upper  ",
"         left corner of the destination area ",
"         and the active region will be copied.",
"  Save - save the active region to a Pixt ",
"         pixmap file.",
"  Fill - fills the active region with the",
"         current color.",
"  Capture - this function is similar to the",
"         Capture function in the Edit menu,",
"         except that only the active region",
"         receives the captured image.",
"  ",
"  ",
"  COMMAND LINE OPTION",
"  ------- ---- ------",
"  ",
"  Currently there is only one command line",
"  option recognized by pixt. The -s option",
"  specifies a size for the pixmap. The default",
"  size is 60 pixels x 60 pixels. If you want to",
"  edit a pixmap of some different size, use the  ",
"  -s option followed by the pixmap dimensions.",
"  For example, if you wanted to edit a pixmap",
"  that was 30 pixels wide by 25 pixels high,",
"  you would invoke pixt thus:",
"     % pixt -s 30x25",
"  ",
"  Pixt does not know about filenames on the",
"  command line so don't even try.",
"  ",
"  ",
"  Pixt was written by:",
"  ",
"	  Mike Flanery",
"	  Mips Computer Systems, Inc.",
"	  15851 North Dallas Parkway",
"	  Suite 755",
"	  Dallas, TX 75248",
"	  (214)770-7979",
"	  flanery@mips.com",
"  ",
"  It is still under development..."
};

CreateHelpText()
{
	int i;
	int size = 0;

	for (i=0;i<XtNumber(helpstr);i++)
		size += strlen(helpstr[i]);
	size += XtNumber(helpstr);
	size++;
	helptext = (char *)malloc(size);
	strcpy(helptext,"");
	for (i=0;i<XtNumber(helpstr);i++) {
		strcat(helptext,helpstr[i]);
		strcat(helptext,"\n");
	}
}
