#include "pixt.h" 
#include <Xm/Text.h>

Widget xuCreateHelpDialog();
XmFontList xuCreateFontList();
void unpostHelp();

Widget menuBtns[NumMenuBtns];
Widget menus[NumMenus];
Widget editBtn[10];
Widget fileBtn[7];
Widget drawBtn[5];
Widget regionBtn[8];
Widget quitBtn;
Widget pBtn3[2];

void ImageCB();
void DrawCB();
void ClearCB();
void QuitCB();
void FileCB();
void ChangeColorCB();
void popHelp();

popInputDialog();
void grabImageCB();
void  regionCB();
void grabRegionImageCB();
extern char *helptext;
XImage *global_xim;
XImage *global_reg_xim;

XmStringCharSet cs = (XmStringCharSet)XmSTRING_DEFAULT_CHARSET;
char *menufontstr="-adobe-times-bold-r-normal--14-100-100-100-p-76-iso8859-1";

Widget CreateMenuBar(parent)
	Widget parent;
{
	Widget menuBar;
	Arg args[15];
	int a, i;

	menuBar = XmCreateMenuBar(parent,"menuBar",NULL,0);
	XtManageChild(menuBar);
	/* create help button for menubar
	 */
	a = 0;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR("Help",cs)); a++;
	menuBtns[Help]  = XmCreateCascadeButton(menuBar,"helpBtn",args,a);
	XtManageChild(menuBtns[Help]);
	XtSetArg(args[0], XmNmenuHelpWidget, (XtArgVal)menuBtns[Help]);
	XtSetValues(menuBar,args,1);
	XtAddCallback(menuBtns[Help],XmNactivateCallback,popHelp,NULL);

	helpDialog = (Widget)xuCreateHelpDialog(toplevel,"helpDialog",
			helptext, menufontstr);
	/*
	** The FILE menu will have the functions for reading and
	** writing pixmap files...
	*/
	menus[File] = XmCreatePulldownMenu(menuBar,"fileMenu",NULL,0);

	a = 0;
	XtSetArg(args[a],XmNsubMenuId, menus[File]); a++;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR("File",cs)); a++;
	XtSetArg(args[a],XmNmnemonic,'F'); a++;
        menuBtns[File] = XmCreateCascadeButton(menuBar,"fileMenuBtn",args,a);
        XtManageChild(menuBtns[File]);

	a = 0;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Read XPM Pixmap",cs)); a++;
	XtSetArg(args[a],XmNsensitive,True); a++;
	XtSetArg(args[a],XmNaccelerator,"<Key>r:"); a++;
	XtSetArg(args[a],XmNacceleratorText,
			 XmStringCreateLtoR("R",XmSTRING_DEFAULT_CHARSET));
			 a++;
	fileBtn[F_READ] = XmCreatePushButtonGadget(menus[File],
				"readPIX",args,a);

	a = 0;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Write XPM Pixmap",cs)); a++;
	XtSetArg(args[a],XmNsensitive,True); a++;
	XtSetArg(args[a],XmNaccelerator,"<Key>w:"); a++;
	XtSetArg(args[a],XmNacceleratorText,
			 XmStringCreateLtoR("W",cs)); a++;
	fileBtn[F_WRITE] = XmCreatePushButtonGadget(menus[File],
				"writePIX",args,a);
	a = 0;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Write UIL Icon",cs)); a++;
	XtSetArg(args[a],XmNsensitive,True); a++;
	fileBtn[F_WRITE_UIL] = XmCreatePushButtonGadget(menus[File],
				"writeUIL",args,a);

	a = 0;
	XtSetArg(args[a],XmNaccelerator,"Ctrl<Key>x:"); a++;
	XtSetArg(args[a],XmNacceleratorText,
			 XmStringCreateLtoR("Ctrl+X",cs)); a++;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Quit Pixt", cs)); a++;
	fileBtn[F_QUIT] = XmCreatePushButtonGadget(menus[File],
				"quit",args,a);
	XtManageChildren(fileBtn,4);

	XtAddCallback(fileBtn[F_QUIT],XmNactivateCallback,QuitCB,NULL);
	XtAddCallback(fileBtn[F_READ],XmNactivateCallback,
				ImageCB,F_READ);
	XtAddCallback(fileBtn[F_WRITE_UIL],XmNactivateCallback,
				ImageCB,F_WRITE_UIL);
	XtAddCallback(fileBtn[F_WRITE],XmNactivateCallback,
				ImageCB,F_WRITE);


	/*
	** The EDIT menu will have the various functions that affect the
	** current pixmap...
	*/
	menus[Edit] =  XmCreatePulldownMenu(menuBar,"editMenu",NULL,0);

	a = 0;
	XtSetArg(args[a],XmNsubMenuId, menus[Edit]); a++;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR("Edit",cs)); a++;
	XtSetArg(args[a],XmNmnemonic,'E'); a++;
	menuBtns[Edit] = XmCreateCascadeButton(menuBar,"editMenuBtn",args,a);
	XtManageChild(menuBtns[Edit]);

	a = 0;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Capture Image from Screen",cs)); a++;
	editBtn[CAPTURE] = XmCreatePushButtonGadget(menus[Edit],
				"capture",args,a);

	a = 0;
	XtSetArg(args[a],XmNaccelerator,"<Key>g:"); a++;
	XtSetArg(args[a],XmNacceleratorText,
			 XmStringCreateLtoR("g",cs)); a++;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Global Color Change from <Btn3> to Current Color",
			cs)); a++;
	editBtn[COLOR_CHANGE] = XmCreatePushButtonGadget(menus[Edit],
				"colorChange",args,a);

	a = 0;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Clear Pixmap",cs)); a++;
	editBtn[CLEAR]    = XmCreatePushButtonGadget(menus[Edit],
				"clear",args,a);

	XtAddCallback(editBtn[CLEAR],XmNactivateCallback, ClearCB, NULL);
	XtAddCallback(editBtn[CAPTURE], XmNactivateCallback,grabImageCB,NULL);
	XtAddCallback(editBtn[COLOR_CHANGE],XmNactivateCallback,
				ChangeColorCB,NULL);	

	XtManageChildren(editBtn,3);

	/*
	** The DRAW menu will contain the functions for doing the basic
	** drawing routines such as line, circles, etc...
	*/
	menus[Draw] =  XmCreatePulldownMenu(menuBar,"editMenu",NULL,0);

	a = 0;
	XtSetArg(args[a],XmNsubMenuId, menus[Draw]); a++;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Draw", cs)); a++;
	XtSetArg(args[a],XmNmnemonic,'D'); a++;
        menuBtns[Draw]  = XmCreateCascadeButton(menuBar,"drawMenuBtn",
				args,a);
	XtManageChild(menuBtns[Draw]);

	a = 0;
	XtSetArg(args[a],XmNaccelerator,"<Key>l:"); a++;
	XtSetArg(args[a],XmNacceleratorText,
			 XmStringCreateLtoR("l",cs)); a++;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Draw a Line", cs)); a++;
	drawBtn[LINE]     = XmCreatePushButtonGadget(menus[Draw],
				"line",args,a);
	XtManageChildren(drawBtn,1);
	XtAddCallback(drawBtn[LINE], XmNactivateCallback, DrawCB, LINE);


	/*
	** The REGION menu will have the various functions that specific
	** regions of the pixmap 
	*/
	menus[Region] =  XmCreatePulldownMenu(menuBar,"regionMenu",NULL,0);

	a = 0;
	XtSetArg(args[a],XmNsubMenuId, menus[Region]); a++;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR("Region",cs)); a++;
	XtSetArg(args[a],XmNmnemonic,'R'); a++;
	menuBtns[Region] = XmCreateCascadeButton(menuBar,"regionMenuBtn",
				args,a);
	XtManageChild(menuBtns[Region]);
	
	a = 0;
	XtSetArg(args[a],XmNsensitive,False); a++;
	XtSetArg(args[a],XmNaccelerator,"<Key>h:"); a++;
	XtSetArg(args[a],XmNacceleratorText,
			 XmStringCreateLtoR("h",cs)); a++;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Hid (Deselect) Region", cs)); a++;
	regionBtn[HIDE_R] = XmCreatePushButtonGadget(menus[Region],
			"hideRegion",args,a);
	a = 0;
	XtSetArg(args[a],XmNsensitive,True); a++;
	XtSetArg(args[a],XmNaccelerator,"<Key>m:"); a++;
	XtSetArg(args[a],XmNacceleratorText,
			 XmStringCreateLtoR("m",cs)); a++;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Mark Region", cs)); a++;
	regionBtn[MARK_R] = XmCreatePushButtonGadget(menus[Region],
			"markRegion",args,a);
	a = 0;
	XtSetArg(args[a],XmNsensitive,False); a++;
	XtSetArg(args[a],XmNaccelerator,"<Key>p:"); a++;
	XtSetArg(args[a],XmNacceleratorText,
			 XmStringCreateLtoR("p",cs)); a++;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Copy Active Region", cs)); a++;
	regionBtn[COPY_R] = XmCreatePushButtonGadget(menus[Region],
			"copyRegion",args,a);
	a = 0;
	XtSetArg(args[a],XmNsensitive,False); a++;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Write Region to XPM Pixmap File", cs)); a++;
	regionBtn[SAVE_R] = XmCreatePushButtonGadget(menus[Region],
			"saveRegion",args,a);
	a = 0;
	XtSetArg(args[a],XmNsensitive,False); a++;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Fill Region With Current Color", cs)); a++;
	regionBtn[FILL_R] = XmCreatePushButtonGadget(menus[Region],
			"fillRegion",args,a);

	a = 0;
	XtSetArg(args[a],XmNsensitive,False); a++;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Capture Screen into Region",cs)); a++;
	regionBtn[CAPTURE_R] = XmCreatePushButtonGadget(menus[Region],
			"captureRegion",args,a);

	a = 0;
	XtSetArg(args[a],XmNlabelString,XmStringCreateLtoR(
			"Read XPM Pixmap into Region",cs)); a++;
	regionBtn[READ_R] = XmCreatePushButtonGadget(menus[Region],
			"readRegion",args,1);

	XtManageChildren(regionBtn,7);	

	XtAddCallback(regionBtn[HIDE_R],XmNactivateCallback,regionCB,HIDE_R);
	XtAddCallback(regionBtn[MARK_R],XmNactivateCallback,regionCB,MARK_R);
	XtAddCallback(regionBtn[COPY_R],XmNactivateCallback,regionCB,COPY_R);
	XtAddCallback(regionBtn[SAVE_R],XmNactivateCallback,regionCB,SAVE_R);
	XtAddCallback(regionBtn[FILL_R],XmNactivateCallback,regionCB,FILL_R);
	XtAddCallback(regionBtn[READ_R],XmNactivateCallback,regionCB,READ_R);
	XtAddCallback(regionBtn[CAPTURE_R],XmNactivateCallback,
			grabRegionImageCB,NULL);

	return(menuBar);
}	

void ImageCB(w,client,call)
	Widget w;
	int client;
	caddr_t call;
{
	XImage *xi;
	Arg args[2];

	switch (client) {
	case F_READ:
		FileState = F_READ;
		ImageType = PIX;
		ImageOp = READ;
		XtSetArg(args[0],XmNdirMask,
			XmStringCreateLtoR("*.xpm",XmSTRING_DEFAULT_CHARSET));
		XtSetValues(fileDialog,args,1);
		XtManageChild(fileDialog);
		break;
	case F_WRITE_UIL:
		FileState = F_WRITE_UIL;
		ImageType = UIL;
		ImageOp = WRITE;
		XtSetArg(args[0],XmNdirMask,
			XmStringCreateLtoR("*.uil",XmSTRING_DEFAULT_CHARSET));
		XtSetValues(fileDialog,args,1);
		XtManageChild(fileDialog);
		break;
	case F_WRITE:
		/* get a copy of the image in case it is needed later... 
		*/
		global_xim = XGetImage(display,pixwin,0,0,
				NumCols,NumRows,
				AllPlanes,ZPixmap);
		FileState = F_WRITE;
		ImageType = PIX;
		ImageOp = WRITE;
		XtSetArg(args[0],XmNdirMask,
			XmStringCreateLtoR("*.xpm",XmSTRING_DEFAULT_CHARSET));
		XtSetValues(fileDialog,args,1);
		XtManageChild(fileDialog);
		break;
	}
}

void ChangeColorCB(w,client,call)
	Widget w;
	int client;
	caddr_t call;
{
	XDefineCursor(display,win,changeCursor);
	ColorChangeMode = 2;
}

void DrawCB(w,client,call)
	Widget w;
	int client;
	caddr_t call;
{
	switch (client) {
	case LINE:
		DrawState = LINE;	
		FirstPoint = True;
		XDefineCursor(display,win,lineCursor);
		break;
	case RECT:
		DrawState = NOOP;	
		break;
	case FRECT:
		DrawState = NOOP;	
		break;
	case CIRC:
		DrawState = NOOP;	
		break;
	case FCIRC:
		DrawState = NOOP;	
		break;
	}
}
void ClearCB(w,client,call)
	Widget w;
	int client;
	caddr_t call;
{
	/* clear the drawing area, the pixel display area, fill in the array
	 * of PixColors with the background color and then redraw the grid
	 */
	int r, c;
	XClearWindow(display,win);
	XClearWindow(display,pixwin);
	DrawGrid(NULL,NULL,NULL);
	for (r=0;r<NumRows;r++)
		for(c=0;c<NumCols;c++)
			PixColors[r*NumCols+c] = PixmapBackground;
}

void QuitCB(w,client,call)
	Widget w;
	int client;
	caddr_t call;
{
	exit(0);
}


void FileCB(w,client,call)
	Widget w;
	int client;
	XmFileSelectionBoxCallbackStruct *call;
{
	/* this callback is only called when the OK button is
	 * selected - because we want the dialog unmapped before 
	 * we draw the image, this callback simply grabs the name
	 * of the file and the unmap callback (UnFileCB) does the
	 * work.
	 */
	char *fname;
	XmStringGetLtoR(call->value,XmSTRING_DEFAULT_CHARSET, 
		&fname);
	strcpy(globalFileName,fname);
	XtUnmanageChild(fileDialog);

}

void UnFileCB(w,client,call)
	Widget w;
	int client;
	XmFileSelectionBoxCallbackStruct *call;
{
	/* this function is called when the file dialog is unmapped--
	 * all of the state vars have been set, it's just up to this
	 * routine to call the right function
	 */
	switch (ImageType) {
	case UIL: 
		if (ImageOp == READ)
			fprintf(stderr,"read an UIL...\n");
		else if (writeUIL() == -1)
				popMessage("Unable to write UIL file");
		break;
	case PIX:
		if (ImageOp == READ) {
	 		if (readPixmap(globalFileName) == -1)
				popMessage("Read of Pixmap failed...");	
		}
		else if (ImageOp == R_WRITE) {
			if (writeRegionPixmap(globalFileName)== -1)
				popMessage("Write of Region Pixmap failed...");
		}
		else if (ImageOp == R_READ) {
			if (readRegionPixmap(globalFileName) == -1)
				popMessage("Write of Region Pixmap failed...");
		}
		else {
			if (writePixmap(0,0,NumCols,NumRows,
				globalFileName)== -1)
				popMessage("Write of Pixmap failed...");
		}
		break;
	}
}


void CancelFileCB(w,client,call)
	Widget w;
	int client;
	caddr_t call;
{
	ImageType = NOOP;
	XtUnmanageChild(fileDialog);
}

popMessage(mess)
	char *mess;
{
	Arg args[5];	
	XmString xmess;
	xmess = XmStringCreateLtoR(mess,XmSTRING_DEFAULT_CHARSET);
	XtSetArg(args[0],XmNmessageString,xmess);
	XtSetValues(messageDialog,args,1);
	XtManageChild(messageDialog);
}

void killMessage(w,client,call)
	Widget w;
	caddr_t client;
	caddr_t call;
{
	XtUnmanageChild(messageDialog);
}
void popHelp(w,client,call)
	Widget w;
	caddr_t client;
	caddr_t call;
{
	XtManageChild(helpDialog);
}


Widget xuCreateHelpDialog(parent, name, helptext, font)
	Widget parent;
	char *name;
	String helptext;
	String font;
{
	Widget dialog, sw, txt, pb;
	Arg rags[15];
	int w, v;
	char str[64];
	Dimension swidth, sheight, width, height;
	XmFontList fl;
	XmString hstr;
	
	fl = xuCreateFontList(font,parent);
	hstr = XmStringCreateSimple(helptext);
	swidth = XmStringWidth(fl,hstr);
	sheight =XmStringHeight(fl,hstr);
	swidth +=  50;
	sheight += 50;
	width = (swidth>700)?700:swidth;
	height= (sheight>400)?400:sheight;
	v = 0;
	XtSetArg(rags[v],XmNwidth,width); v++;
	XtSetArg(rags[v],XmNheight,height); v++;
	XtSetArg(rags[v],XmNdialogStyle,XmDIALOG_APPLICATION_MODAL); v++;
	dialog = XmCreateFormDialog(parent,name,rags,v);

	XtSetArg(rags[0],XmNtitle,name); 
	XtSetValues(XtParent(dialog),rags,1);

	strcpy(str,name);
	strcat(str,"SW");
	v = 0;
	XtSetArg(rags[v],XmNscrollBarDisplayPolicy,XmAS_NEEDED); v++;
	XtSetArg(rags[v],XmNscrollingPolicy,XmAUTOMATIC); v++;
	XtSetArg(rags[v],XmNtopAttachment,XmATTACH_FORM); v++;
	XtSetArg(rags[v],XmNtopOffset,5); v++;
	XtSetArg(rags[v],XmNbottomAttachment,XmATTACH_POSITION); v++;
	XtSetArg(rags[v],XmNbottomPosition,90); v++;
	XtSetArg(rags[v],XmNleftOffset,5); v++;
	XtSetArg(rags[v],XmNrightOffset,5); v++;
	XtSetArg(rags[v],XmNleftAttachment,XmATTACH_FORM); v++;
	XtSetArg(rags[v],XmNrightAttachment,XmATTACH_FORM); v++;
	sw = XmCreateScrolledWindow(dialog,str,rags,v);
	XtManageChild(sw);

	strcpy(str,name);
	strcat(str,"TXT");
	v = 0;
	XtSetArg(rags[v],XmNeditable,False); v++;
	XtSetArg(rags[v],XmNbackground,xuStr2Pix("light blue",parent)); v++;
	XtSetArg(rags[v],XmNfontList,xuCreateFontList(font,parent)); v++;
	txt = XmCreateText(sw,str,rags,v);
	XtManageChild(txt);
	XmTextSetString(txt,helptext);

	strcpy(str,name);
	strcat(str,"PB");
	v = 0;
	XtSetArg(rags[v],XmNlabelString,XmStringCreateSimple("OK")); v++;
	XtSetArg(rags[v],XmNtopAttachment,XmATTACH_POSITION); v++;
	XtSetArg(rags[v],XmNtopPosition,92); v++;
	XtSetArg(rags[v],XmNleftAttachment,XmATTACH_POSITION); v++;
	XtSetArg(rags[v],XmNleftPosition,90); v++;
	XtSetArg(rags[v],XmNwidth,50); v++;
	XtSetArg(rags[v],XmNheight,30); v++;
	pb = XmCreatePushButton(dialog,str,rags,v);
	XtAddCallback(pb,XmNactivateCallback,unpostHelp,dialog);
	XtManageChild(pb);

	return (dialog);
}

XmFontList xuCreateFontList(name,w)
        char *name;
        Widget w;
{
        XFontStruct *xfs;
        XmFontList xmfl;

        if ((xfs = XLoadQueryFont(XtDisplay(w),name)) == NULL)
                if ((xfs = XLoadQueryFont(XtDisplay(w),"fixed")) == NULL)
                        return ((XmFontList) -1);

        /* at this point we have loaded some font or already returned */
        return(XmFontListCreate(xfs,XmSTRING_DEFAULT_CHARSET));
}

void unpostHelp(w,client,call)
        Widget w;
        Widget client;
        caddr_t call;
{
        XtUnmanageChild(client);
}

