#include "pixt.h"

/* the porpoise of this routine is to create the colored buttons
 * that change the CurrentColor...
 */

extern void selectColorCB();
Pixel xuStr2Pix();

CreateColorPalette(parent)
	Widget parent;
{
	Widget colorRoCo;
        Widget colorbtns[NUMCOLORS];

	int n, i;
	Arg args[15];

	/* the 'colorPane' is a label widget inside a frame. the label
 	 * is used to display the currently selected color
 	 */
	n = 0;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNleftWidget,mainSWin); n++;
        colorPane[0] = XmCreateFrame(parent,"colorPaneFrame",args,n);
        XtManageChild(colorPane[0]);

	n = 0;
	XtSetArg(args[n],XmNwidth,105); n++;
	XtSetArg(args[n],XmNheight,40); n++;
        XtSetArg(args[n],XmNlabelString,
                	 XmStringCreateLtoR("  ",XmSTRING_DEFAULT_CHARSET));n++;
        colorPane[1]  = (Widget)XmCreateLabel(colorPane[0],"colorPane",args,n);
        XtManageChild(colorPane[1]);

	/* the color palette...
  	 */
	n = 0;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNleftWidget,mainSWin);            n++;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_WIDGET);  n++;
	XtSetArg(args[n],XmNtopWidget,colorPane[0]);         n++;
        colorFrame = XmCreateFrame(parent,"colorFrame",args,n);
        XtManageChild(colorFrame);


	n = 0;
	XtSetArg(args[n],XmNnumColumns,6);                      n++;
	XtSetArg(args[n],XmNorientation,XmHORIZONTAL);          n++;
	XtSetArg(args[n],XmNpacking,XmPACK_COLUMN);             n++;
        colorRoCo = XmCreateRowColumn(colorFrame,"colorRoCo",args,n);
        XtManageChild(colorRoCo);

	XtSetArg(args[0],XmNwidth,30);				
	XtSetArg(args[1],XmNheight,30);				
	XtSetArg(args[2],XmNtopShadowColor,
			 xuStr2Pix("light gray",toplevel));
	XtSetArg(args[3],XmNbottomShadowColor,
 			 xuStr2Pix("dim gray",toplevel));
	XtSetArg(args[4],XmNarmColor,
			 xuStr2Pix("dim gray",toplevel));
	XtSetArg(args[5],XmNforeground,WhitePixel(display,
			 DefaultScreen(display)));	
	XtSetArg(args[6],XmNhighlightThickness,0);
	XtSetArg(args[7],XmNborderColor,BlackPixel(display,
			 DefaultScreen(display)));
        for (i=0;i<XtNumber(colornames);i++) {
                if ((XParseColor(display,cmap,
			colornames[i],&(colors[i])))==0)
                        fprintf(stderr,"parsing of %s failed\n",
				colornames[i]);
                if ((XAllocColor(display,cmap,&(colors[i]))) ==0)
                        fprintf(stderr,"allocation of %s failed\n",
				colornames[i]);
                XtSetArg(args[8], XmNbackground,colors[i].pixel);
                colorbtns[i] = XmCreatePushButton(colorRoCo," ",args,9);
                XtManageChild(colorbtns[i]);
                XtAddCallback(colorbtns[i],XmNactivateCallback,
                                selectColorCB, i);
	}
}


Pixel xuStr2Pix(spec, w)
char *spec;     /* color name */
Widget w;       /* a widget pointer */
{
	Colormap cmap;
	XColor color_struct;
	Display  *dpy;

	dpy = XtDisplay(w);  

	cmap = XDefaultColormap(dpy, DefaultScreen(dpy));

	if (!XParseColor(dpy, cmap, spec, &color_struct)) {
		fprintf(stderr,"Invalid color name\n");
		return((Pixel)0);
	}

	if (!XAllocColor(dpy, cmap, &color_struct)) 
		return((Pixel)0);
	else
  		return(color_struct.pixel);
}
