#include <stdio.h>

#include <X11/Xos.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xresource.h>
#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/MainW.h>
#include <Xm/CascadeB.h>
#include <Xm/RowColumn.h>
#include <Xm/BulletinB.h>
#include <Xm/DrawingA.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/Form.h>
#include <Xm/PushBG.h>
#include <Xm/PushB.h>
#include <Xm/FileSB.h>
#include <Xm/MessageB.h>
#include <Xm/SeparatoG.h>
#include <Xm/SelectioB.h>
#include "xpm.h"

#include "colornames.h"

#define CELLSIZE        10
#define MARGIN		10
#define CANCEL	0
#define OK	1
#define SWIN_MAX_COLS	60
#define SWIN_MAX_ROWS	60
#define SWIN_PAD	25
#define SWIN_MAX_WIDTH	(SWIN_MAX_COLS+1)*CELLSIZE+MARGIN+MARGIN+SWIN_PAD
#define SWIN_MAX_HEIGHT	(SWIN_MAX_ROWS+1)*CELLSIZE+MARGIN+MARGIN+SWIN_PAD

#define MAX_POSSIBLE_CELLS	4096 /* this is the maximum number of 
				     * colormap cells one is likely to
				     * encounter...
				     */

#define NumMenuBtns     5
#define NumMenus        4

#define File            0
#define Edit            1
#define Draw            2
#define Region		3
#define Help            4

/* the ImageOps */
#define READ    0
#define WRITE   1
#define R_WRITE 2
#define R_READ  3

/*
** the ImageTypes
*/
#define XIM     0
#define UIL     1
#define PIX     2


#define NOOP		-1
/*
** the File menu items...
*/
#define F_READ        0
#define F_WRITE       1
#define F_WRITE_UIL   2
#define F_QUIT        3

/*
** the Edit menu items
*/
#define CAPTURE         0
#define COLOR_CHANGE	1
#define CLEAR           2

/*
** DRAW menu items
** these are also the DrawState states...
*/
#define LINE            0
#define RECT            1
#define FRECT           2
#define CIRC            3
#define FCIRC           4
#define DRAW_SEP	5
/* need a DrawState for region... */
#define REGION 		7


/*
** REGION menu items
*/
#define HIDE_R		0
#define MARK_R		1
#define COPY_R		2
#define SAVE_R		3
#define FILL_R		4
#define CAPTURE_R       5
#define READ_R		6
#define CHANGE_R	7

#define NumPushButtons  13




#ifdef MAIN
#define EXT /**/
#else
#define EXT extern
#endif

/*
** the type  for defining a Region
*/
typedef struct {
	int row;
	int col;
	int width;
	int height;
} PixRegion;


/* 
** the globals
*/
EXT	PixRegion ActiveRegion;
EXT 	Boolean RegionFirst;
EXT	Window pixwin;
EXT	Window win;
EXT	Display *display;
EXT	GC paintGC;
EXT 	GC paintGCs[XtNumber(colornames)];
EXT     GC highlightGC;
EXT 	GC gridGC;
EXT	GC eraseGC;
EXT	unsigned long *PixColors;
EXT     XSegment *ColSegs;
EXT     XSegment *RowSegs;
EXT	int NumRows; 
EXT	int NumCols;
EXT	int dAreaW; 
EXT 	int dAreaH;
EXT	XColor colors[XtNumber(colornames)+1];
/*
EXT	unsigned long *ColorTable;
*/
EXT	unsigned long ColorTable[4096];
EXT	int PixmapBackground;
EXT	Widget fileDialog;
EXT 	Widget fileShell;
EXT	Widget helpDialog;
EXT	Widget messageDialog;
EXT	int DrawState;
EXT 	int RegionOp;
EXT	int FileState;
EXT	Cursor lineCursor;
EXT	Cursor gridCursor;
EXT	Cursor mainCursor;
EXT	Cursor changeCursor;
EXT	Cursor regionCursor;
EXT	Boolean FirstPoint;
EXT	int ColorChangeMode;
EXT	Colormap cmap;
EXT	Widget colorPane[2];
EXT	Widget imageWorking;
EXT	Window imagewin;
EXT	Widget toplevel;
EXT	Widget colorFrame;
EXT	Widget mainSWin;
EXT	Boolean ColorMatch;
EXT	Widget inDialog;
EXT	Widget inDialogText;
EXT	Widget inDialogLabel;
EXT	char globalFileName[256];

/* the default states */
EXT	int ImageType;
EXT	int ImageOp;
